@connect /
set echo on
/*
Consider this simple transaction
We want to maintain a rollup in a parent
based on a child:


insert into child_table ( primary_key, foreign_key, x ) values (100, 5, 1);

update parent_table 
   set child_sum = 
    ( select sum(x)
        from child_table
       where child_table.foreign_key = parent_table.primary_key )
 where parent_table.primary_key = 5;
commit; 
*/
pause

drop table child;
drop table parent;

create table parent
( primary_key int primary key,
  child_sum int
);

create table child
( primary_key int primary key,
  foreign_key references parent,
  x int
);


insert into parent (primary_key) values (1);
insert into parent (primary_key) values (2);

insert into child(primary_key,foreign_key,x) values ( 100, 1, 55 );
insert into child(primary_key,foreign_key,x) values ( 101, 1, 50 );
update parent
   set child_sum =
    ( select sum(x)
        from child
       where child.foreign_key = parent.primary_key )
 where parent.primary_key = 1;
commit;
pause

select * from parent;
select * from child;
pause

insert into child values ( 102, 1, 10 );
update parent
   set child_sum =
     (select sum(x)
        from child
       where child.foreign_key = parent.primary_key )
  where parent.primary_key = 1;

-- in another session, execute demo002a.sql
pause

commit;

select * from parent;
select * from child;
